package io.github.null2264.tsukumogami.core.commands.ext

import dev.kord.core.entity.User
import io.github.null2264.tsukumogami.core.commands.Arguments
import io.github.null2264.tsukumogami.core.commands.converters.Converter
import io.github.null2264.tsukumogami.core.commands.converters.impl.StringConverter
import io.github.null2264.tsukumogami.core.commands.converters.impl.UserConverter

fun Arguments.string(name: String, declaration: Converter<String>.() -> Unit = {}): Converter<String> {
    val converter = StringConverter()
    declaration(converter)
    return args(name, converter)
}

fun Arguments.user(name: String, declaration: Converter<User>.() -> Unit = {}): Converter<User> {
    val converter = UserConverter()
    declaration(converter)
    return args(name, converter)
}
